<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="search.keyWord" placeholder="关键字" style="width: 200px;" class="filter-item" />
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="searchData">
        搜索
      </el-button>
      <el-button
        v-if="webType && isChoose == false"
        class="filter-item"
        style="margin-left: 10px;"
        type="primary"
        icon="el-icon-plus"
        @click="handleCreateAdd">
        增加机型档案
      </el-button>
    </div>
    <el-table
      :data="tableData"
      v-loading="listLoading"
      style="width: 100%;margin-bottom: 20px;"
      row-key="id"
      border
      default-expand-all>
      <el-table-column label="操作" align="center" width="230" class-name="small-padding fixed-width">
        <template slot-scope="{row}">
          <template v-if="webType">
            <template v-if="!isChoose">
          <el-button @click="handleUpdate(row)" type="primary" size="mini">
            编辑
          </el-button>
          <el-button @click="editStatus(row.id,'1')" type="danger" v-if="row.voidFlag==0" size="mini">
            禁用
          </el-button>
          <el-button @click="editStatus(row.id,'0')" v-else="row.voidFlag==1" size="mini">
            启用
          </el-button>
            </template>
            <template v-else>
              <el-button @click="chooseThis(row)" type="primary" size="mini">
                选择
              </el-button>
            </template>
          </template>
          <template v-else>
            <el-button @click="ERPChoose(row)" type="primary" size="mini">
              选择
            </el-button>
          </template>
        </template>
      </el-table-column>
      <el-table-column
        prop="typeName"
        label="机型名称"
        width="180">
      </el-table-column>
     <el-table-column
        label="机型规格"
        prop="machineSize"
      >
      </el-table-column>
      <el-table-column
        prop="minPaperSize"
        label="最小进纸尺寸">
      </el-table-column>
      <el-table-column
        prop="maxPaperSize"
        label="最大进纸尺寸">
      </el-table-column>
      <el-table-column
        prop="psSize"
        label="ps版规格">
      </el-table-column>
      <el-table-column align="center" label="状态" class-name="status-col" width="100">
        <template slot-scope="{row}">
          <el-tag v-if="row.voidFlag==0" type="success">
            启用
          </el-tag>
          <el-tag v-else-if="row.voidFlag==1" type="danger">
            禁用
          </el-tag>
        </template>
      </el-table-column>

    </el-table>
    <pagination v-show="listData.total>0" :total="listData.total" :page.sync="listData.page" :limit.sync="listData.pageSize" @pagination="getInfo" />

    <el-dialog :title="dialogTitle" :visible.sync="dialogVisible" width="480px">
      <el-form label-width="130px" label-position="right">
        <el-form-item label="机型名称">
          <el-input v-model="form.typeName"></el-input>
        </el-form-item>
        <el-form-item label="机型规格">
          <el-input v-model="form.machineSize"></el-input>
        </el-form-item>
        <el-form-item label="最小进纸尺寸">
          <el-input v-model="form.minPaperSize"></el-input>
        </el-form-item>
        <el-form-item label="最大进纸尺寸">
          <el-input v-model="form.maxPaperSize"></el-input>
        </el-form-item>
        <el-form-item label="ps版规格">
          <el-input v-model="form.psSize"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="dialogStatus==='1'?addBtn():editBtn()">确 定</el-button>
      </div>
    </el-dialog>
<!--    <servicedialog @tableRefresh="tableRefresh" ref="menuDialog" :dialogStatus="dialogStatus" :menuId="menuId" :titleDialog="titleDialog" :dialogVisible="dialogVisible"/>-->
    <cancledialog @tableRefresh="tableRefresh" ref="confirmDialog"></cancledialog>
  </div>
</template>

<script>
import { addPrinterTypeInfo, getPrinterTypeList, getPrinterTypeInfo, editPrinterType } from '@/api/baseInfo/printerType.js'
import Cancledialog from '@/components/Dialog/Cancledialog.vue'
import Pagination from '@/components/Pagination'

export default {
  components: {
    Cancledialog, Pagination
  },
  filters: {
    statusFilter(status) {
      const statusMap = {
        1: 'success',
        0: 'danger'
      }
      return statusMap[status]
    }
  },
  props: {
    isChoose: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      webType: true,
      dialogStatus: 1, // 1增加，2修改
      dialogTitle: '',
      dialogVisible: false,
      search: {
        keyWord: ''
      },
      form: {
        typeName: '',
        machineSize: '',
        maxPaperSize: '',
        minPaperSize: '',
        psSize: ''
      },
      listData: {
        total: 0,
        page: 1,
        pageSize: 10
      },

      options: [],

      confirmdialog: false,
      listLoading: false,
      tableData: [],
      menuId: ''
    }
  },
  mounted() {
    this.getInfo()
    if (this.$route.query.type === undefined) {
      this.webType = true
    } else {
      this.webType = false
    }
  },
  methods: {
    // 获取列表
    getInfo() {
      const _that = this
      _that.listLoading = true

      var params = _that.search
      var page = {
        pageIndex: _that.listData.page,
        pageSize: _that.listData.pageSize
      }
      var data = {
        'params': JSON.stringify(params),
        'page': JSON.stringify(page)
      }

      getPrinterTypeList(data).then(response => {
        console.log(response)
        const data = response.data
        // //  组合表单数据
        _that.tableData = data
        // console.log(_that.tableData)
        _that.listData.total = response.total
        _that.listLoading = false
      }).catch(err => {
        _that.$message.error(err)
        _that.listLoading = false
      })
    },
    // 增加机型档案
    handleCreateAdd() {
      // 增加系统目录
      const _that = this
      _that.form = {}
      _that.dialogTitle = '增加机型档案'
      _that.dialogStatus = '1'
      _that.dialogVisible = true
    },
    // 刷新变革
    tableRefresh() {
      // 刷新变革
      this.getInfo()
    },
    // 增加机型档案
    addBtn() {
      const _that = this
      var printerTypeInfo = JSON.stringify(_that.form)
      var data = {
        'machineType': printerTypeInfo
      }
      // console.log(data);
      // return

      addPrinterTypeInfo(data).then(res => {
        console.log('addPrinterTypeInfo', res)
        if (res.httpCode == 200) {
          _that.dialogVisible = false
          _that.$message({
            message: '增加成功',
            type: 'success'
          })
          _that.tableRefresh()
        } else {
          _that.$message.error(res.msg)
        }
      }).catch(err => {
        _that.$message.error(err)
        _that.dialogVisible = true
      })
    },

    // 唤起修改
    handleUpdate(row) {
      const _that = this
      _that.form = {}

      _that.dialogTitle = '修改机型档案信息'
      _that.dialogVisible = true
      _that.dialogStatus = '2'

      var idPrint = row.id
      var data = {
        idMachineType: idPrint
      }

      getPrinterTypeInfo(data).then(res => {
        console.log('getPrinterTypeInfo', res)
        const data = res.data

        _that.form = {
          id: data.id,
          typeName: data.typeName,
          machineSize: data.machineSize,
          maxPaperSize: data.maxPaperSize,
          minPaperSize: data.minPaperSize,
          psSize: data.psSize
        }
      }).catch(err => {
        _that.$message.error(err)
      })
    },
    // 修改机型档案
    editBtn() {
      const _that = this
      var printerTypeInfo = JSON.stringify(_that.form)
      var data = {
        'machineType': printerTypeInfo
      }

      editPrinterType(data).then(res => {
        // console.log(res);
        if (res.httpCode == 200) {
          _that.dialogVisible = false
          _that.$message({
            message: '修改成功',
            type: 'success'
          })
          _that.tableRefresh()
        } else {
          _that.$message.error(res.msg)
        }
      }).catch(err => {
        _that.$message.error(err)
        _that.dialogVisible = true
      })
    },

    // 启用禁用
    editStatus(id, status) {
      var _that = this
      var printerTypeInfo = {
        id: id,
        voidFlag: status
      }
      var params = {
        'machineType': JSON.stringify(printerTypeInfo)
      }

      var url = '/doc/voidMachineType'
      _that.$refs.confirmDialog.updataClick(params, url)
    },

    // 搜索
    searchData() {
      this.listData.page = 1
      this.getInfo()
    },
    // 弹窗内选择操作
    chooseThis(row) {
      // console.log('点击选择');
      this.$emit('choosePrinterType', row)
    },
    ERPChoose(row) {
      // this.$message.error(row)
      dyERP.sendJson(JSON.stringify(row))
    }
  }
}
</script>

<style lang="scss" scoped>
  .filter-container {
    margin-bottom: 15px;
  }
</style>
